// DetailSnapshotDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DetailSnapshotDlg.h"
//#include "afxdialogex.h"


// CDetailSnapshotDlg _CAO

IMPLEMENT_DYNAMIC(CDetailSnapshotDlg, CDialog)

CDetailSnapshotDlg::CDetailSnapshotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDetailSnapshotDlg::IDD, pParent)
{

}

CDetailSnapshotDlg::~CDetailSnapshotDlg()
{
}

void CDetailSnapshotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FOLDER, m_xcEditFolder);
	DDX_Control(pDX, IDC_CMB_FORMAT, m_xcCmbFormat);
	DDX_Control(pDX, IDC_EDIT_JPEG_QUALITY, m_xcEditJpegQuality);
	DDX_Control(pDX, IDC_SPIN_JPEG_QUALITY, m_xcSpinJpegQuality);
	DDX_Control(pDX, IDC_CHECK_DISPLAY, m_xcCheckDisplay);
	DDX_Control(pDX, IDC_CHECK_FIT, m_xcCheckFit);
}

void CDetailSnapshotDlg::InitControls()
{
	m_xcEditFolder.SetWindowText(snapshot_.folder.c_str());
	m_xcCmbFormat.SetCurSel(snapshot_.format);
	m_xcSpinJpegQuality.SetPos32(snapshot_.jpegQuality);
	m_xcCheckDisplay.SetCheck(snapshot_.display ? BST_CHECKED : BST_UNCHECKED);
	m_xcCheckFit.SetCheck(snapshot_.fit ? BST_CHECKED : BST_UNCHECKED);
}

BEGIN_MESSAGE_MAP(CDetailSnapshotDlg, CDialog)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTN_FOLDER, &CDetailSnapshotDlg::OnBnClickedBtnFolder)
	ON_BN_CLICKED(IDC_BTN_ALL_DEFAULT, &CDetailSnapshotDlg::OnBnClickedBtnAllDefault)
END_MESSAGE_MAP()


// CDetailSnapshotDlg bZ[W nh[


BOOL CDetailSnapshotDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcCmbFormat.InsertString(0, L"BMP");
	m_xcCmbFormat.InsertString(1, L"JPEG");
	m_xcCmbFormat.InsertString(2, L"PNG");

    m_xcSpinJpegQuality.SetRange32(0, 100);
	
	InitControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDetailSnapshotDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDetailSnapshotDlg::OnDestroy()
{
	CDialog::OnDestroy();

	CString folder;
	m_xcEditFolder.GetWindowText(folder);
	snapshot_.folder = folder;
	snapshot_.format = m_xcCmbFormat.GetCurSel();
	snapshot_.jpegQuality = m_xcSpinJpegQuality.GetPos32();
	snapshot_.display = m_xcCheckDisplay.GetCheck() == BST_CHECKED;
	snapshot_.fit = m_xcCheckFit.GetCheck() == BST_CHECKED;
}


void CDetailSnapshotDlg::OnBnClickedBtnFolder()
{
	CString tmp;
	m_xcEditFolder.GetWindowText(tmp);

	std::wstring path = utl::toFullpath(gl_.current, std::wstring(tmp));
	std::wstring folder;
	if (utl::folderBrowser(GetSafeHwnd(), path, folder))
	{
		m_xcEditFolder.SetWindowText(folder.c_str());
	}
}


void CDetailSnapshotDlg::OnBnClickedBtnAllDefault()
{
	snapshot_ = sl::SnapshotConfig();
	InitControls();
}
