#include "stdafx.h"

namespace sl {

void put(XmlParser& p, const std::vector<DecoderInfo>& data)
{
	for (auto it = data.begin(); it != data.end(); ++it)
	{
		auto item = p.add(L"item");
		item.put(L"enable", it->enable);
		item.put(L"name", it->name);

		std::vector<OLECHAR> id;
		id.resize(1024, 0);
		StringFromGUID2(it->id, id.data(), (int)id.size());
		item.put(L"id", std::wstring(id.data()));
	}
}

void put(XmlParser& root, const DetailConfig& detail)
{
	auto p = root.put(L"detail");

	p = root.put(L"detail.network");
	p.put(L"stop", detail.network.stop);

	p = root.put(L"detail.network.connect");
	p.put(L"timeout", detail.network.connect.timeout);
	p.put(L"count", detail.network.connect.count);
	p.put(L"wait", detail.network.connect.wait);
	p.put(L"stop", detail.network.connect.stop);

	p = root.put(L"detail.network.reconnect");
	p.put(L"interval", detail.network.reconnect.interval);

	p = root.put(L"detail.network.relay.manual");
	p.put(L"reconnect", detail.network.relay.manual.reconnect);
	p.put(L"stop", detail.network.relay.manual.stop);

	p = root.put(L"detail.network.relay.automatic");
	p.put(L"reconnect", detail.network.relay.automatic.reconnect);
	p.put(L"stop", detail.network.relay.automatic.stop);

	p = root.put(L"detail.network.rebuild");
	p.put(L"wait", detail.network.rebuild.wait);

	p = root.put(L"detail.network.reader");
	p.put(L"userAgent", detail.network.reader.userAgent);
	p.put(L"timeout", detail.network.reader.timeout);

	p = root.put(L"detail.type.flv");
	p.put(L"loop", detail.type.flv.loop);
	p.put(L"keyframe", detail.type.flv.keyframe);
	p.put(L"timestamp", detail.type.flv.timestamp);
	p.put(L"buffer", detail.type.flv.buffer);
	p.put(L"optimize", detail.type.flv.optimize);
	p.put(L"delay", detail.type.flv.delay);
	p.put(L"limit", detail.type.flv.limit);
	p.put(L"interval", detail.type.flv.interval);

	p = root.put(L"detail.decoder");
	p.put(L"dxva2", detail.decoder.dxva2);

	p = root.put(L"detail.video");
	put(p, detail.video);

	p = root.put(L"detail.audio");
	put(p, detail.audio);

	p = root.put(L"detail.browser");
	p.put(L"def", detail.browser.def);
	p.put(L"web", detail.browser.web);
	p.put(L"bbs", detail.browser.bbs);

	p = root.put(L"detail.snapshot");
	p.put(L"folder", detail.snapshot.folder);
	p.put(L"format", detail.snapshot.format);
	p.put(L"jpegQuality", detail.snapshot.jpegQuality);
	p.put(L"display", detail.snapshot.display);
	p.put(L"fit", detail.snapshot.fit);

	p = root.put(L"detail.board");
	p.put(L"contact", detail.board.contact);
	p.put(L"change", detail.board.change);
	p.put(L"userAgent", detail.board.userAgent);
	p.put(L"timeout", detail.board.timeout);
	p.put(L"shitaraba", detail.board.shitaraba);
	p.put(L"reload", detail.board.reload);
	p.put(L"interval", detail.board.interval);
	p.put(L"retry", detail.board.retry);
	p.put(L"thread", detail.board.thread);
	p.put(L"board", detail.board.board);
	p.put(L"move", detail.board.move);
	p.put(L"res", detail.board.res);
	p.put(L"delay", detail.board.delay);
	p.put(L"position", detail.board.position);
	p.put(L"under", detail.board.under);
	p.put(L"align", detail.board.align);
	p.put(L"order", detail.board.order);
	p.put(L"scroll", detail.board.scroll);

	p = root.put(L"detail.board.url");
	put(p, detail.board.url);

	p = root.put(L"detail.board.message");
	put(p, detail.board.message);

	p = root.put(L"detail.start");
	p.put(L"recent", detail.start.recent);

	p = root.put(L"detail.end");
	p.put(L"pos", detail.end.pos);
	p.put(L"size", detail.end.size);
	p.put(L"aspect", detail.end.aspect);
	p.put(L"volume", detail.end.volume);
	p.put(L"balance", detail.end.balance);
	p.put(L"mute", detail.end.mute);
}

} // namespace sl
